#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct VideoOpts {
    #[builder(custom(type = super::IngestSource, convert = Box::new))]
    #[serde(rename = "source")]
    source: Box<super::IngestSource>,
    #[builder(custom(type = super::VideoIngestTarget, convert = Box::new))]
    #[serde(rename = "target")]
    target: Box<super::VideoIngestTarget>,
    #[builder(
        custom(
            type = super::super::super::scout::video::api::VideoFileTimestampManifest,
            convert = Box::new
        )
    )]
    #[serde(rename = "timestampManifest")]
    timestamp_manifest: Box<
        super::super::super::scout::video::api::VideoFileTimestampManifest,
    >,
    #[builder(default, into)]
    #[serde(
        rename = "overWriteSegments",
        skip_serializing_if = "Option::is_none",
        default
    )]
    over_write_segments: Option<bool>,
}
impl VideoOpts {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        source: super::IngestSource,
        target: super::VideoIngestTarget,
        timestamp_manifest: super::super::super::scout::video::api::VideoFileTimestampManifest,
    ) -> Self {
        Self::builder()
            .source(source)
            .target(target)
            .timestamp_manifest(timestamp_manifest)
            .build()
    }
    #[inline]
    pub fn source(&self) -> &super::IngestSource {
        &*self.source
    }
    #[inline]
    pub fn target(&self) -> &super::VideoIngestTarget {
        &*self.target
    }
    #[inline]
    pub fn timestamp_manifest(
        &self,
    ) -> &super::super::super::scout::video::api::VideoFileTimestampManifest {
        &*self.timestamp_manifest
    }
    /// If true, overlapping segments from other video files within the same video will be deleted
    /// before inserting new segments. The cached segment metadata for affected files will be recomputed.
    #[inline]
    pub fn over_write_segments(&self) -> Option<bool> {
        self.over_write_segments.as_ref().map(|o| *o)
    }
}
